require "pry"

module PryLessSource
  Pry::Commands.create_command 'less-source' do
    banner <<-'BANNER'
      Usage: less-source [METH]
      Alias: less [METH]
      
      Description:
        Call less command for method with line number.
        So this command is only for UNIX-like OS.
 
      Example:
        less-source Pry.main
        less-source Pry::Commands.find_command
        
      About options:
        Option is not need.
        But it was needed for error escaping to create this command.
    BANNER
    
    # If this method is none, error occur!
    def options(opt)
      method_options(opt)
    end

    def process
      meth = method_object

      ENV["METH_FILE_PATH"] = meth.source_location[0]
      ENV["METH_LINE_NUM"] = meth.source_location[1].to_s
      
      system('less +$METH_LINE_NUM -N $METH_FILE_PATH')
    end
    
    Pry::Commands.alias_command 'less', 'less-source'
  end
end
